#include "debug_printer.h"


debug_printer* debug_printer::p_instance = 0;


/**
 * Create an instance
 */
debug_printer*
debug_printer::instance() {
  
  // Is this the first call?
  if (p_instance == 0) {
    p_instance = new debug_printer;
  }

  return p_instance;
}


/**
 * Prints a message only if its level of importance is above the
 * current debug level.
 */
void 
debug_printer::dprint(unsigned int level, const char* format, ...) const {
  va_list arg_list;
  
  va_start(arg_list, format); // initialize the vararg list
  
  if (debug_level >= level) {
    std::cout << sc_time_stamp() << " " << sc_delta_count();
    for (unsigned int i=0; i<level; i++)
      printf(" ");

    vprintf(format, arg_list);
  }

  va_end(arg_list); //clean up
}

/**
 * Boring constructor
 */
debug_printer::debug_printer() {
  debug_level = 0;
}

/**
 * Sets the debugging level 
 */
void
debug_printer::set_level(unsigned int level) {
  debug_level = level;
}

