#ifndef DEBUG_PRINTER_H
#define DEBUG_PRINTER_H

#include <stdarg.h> // for variable argument functions
#include <stdio.h>  // in/out
#include <iostream>
#include <systemc.h>

#define DP debug_printer::instance()

class debug_printer {

 public:

  // Constructor
  static debug_printer* instance();
  
  // Debugging print
  void dprint(unsigned int level, const char* format, ...) const;

  // Set the debugging level
  void set_level(unsigned int level);


 protected:
  debug_printer();
  debug_printer(const debug_printer&);
  debug_printer& operator= (const debug_printer&);
  
  unsigned int debug_level; //for debugging printing

 private:
  static debug_printer* p_instance;
};

#endif
