#ifdef MONITOR_1

#include "monitor1.h"


// The constructor
monitor1::monitor1(mon_observer* obs, adder* obj1) : mon_prototype() {
  observer = obs;
  object1 = obj1;
  
  DP->dprint(7, "monitor1::constructor(): registering with the observer\n");
  observer->register_monitor(this, MON_DELTA_CYCLE_END);
  
  DP->dprint(7, "monitor1::constructor(): finished execution\n");
}

  
const char* 
monitor1::to_string() const {
  return "Monitor 1: adder::_a > 0 @ end of delta cycles";
}


void 
monitor1::callback_delta_cycle_end() {
  DP->dprint(8, "monitor1::%s() starts execution\n", __FUNCTION__);
  
  // Check the property below
  sc_assert((object1->_a) >= 0);
  
  DP->dprint(8, "monitor1::%s() finished execution\n", __FUNCTION__);
}

#endif
