#ifdef MONITOR_2
#include "monitor2.h"

/**
 * Constructor
 */
monitor2::monitor2(mon_observer* obs) : mon_prototype() {
  observer = obs;
  num_complete_delta_cycles = 0;
  expected_result = -1;

  monitor_id = get_id();
  
  DP->dprint(7, "property2::monitor %d::constructor(): registering with the observer\n", monitor_id);
  DP->dprint(7, "property2::constructor(): Sample point: MON_DELTA_CYCLE_END\n");
  
  observer->register_monitor(this, MON_DELTA_CYCLE_END);
  
  DP->dprint(7, "property2::monitor %d::constructor(): finished execution\n", monitor_id);
}
  
/**
 * Destructor
 */
monitor2::~monitor2() {
  DP->dprint(7, "property2::monitor %d::destructor()\n", monitor_id);
}



const char* 
monitor2::to_string() const {
    return "answer within two of request";
}


  

void 
monitor2::callback_delta_cycle_end() {
    DP->dprint(8, "property2::monitor %d::%s() starts execution\n",monitor_id, __FUNCTION__ );

    DP->dprint(8, "The value of num_complete_delta_cycles was %d\n", num_complete_delta_cycles);
    num_complete_delta_cycles++;
    DP->dprint(8, "The value of num_complete_delta_cycles is now %d\n", num_complete_delta_cycles);
    
    DP->dprint(8, "property2::monitor %d::%s() finished execution\n", monitor_id,__FUNCTION__);
  }

  
void 
monitor2::callback_received_inputs(int a, int b) {
    DP->dprint(8, "property2::monitor %d::%s(%d, %d) starts execution\n", monitor_id, __FUNCTION__, a, b);
    // The driver has received a new task

    DP->dprint(8, "The value of num_complete_delta_cycles was %d\n", num_complete_delta_cycles);

    num_complete_delta_cycles = 0;

    DP->dprint(8, "The value of num_complete_delta_cycles is now %d\n", num_complete_delta_cycles);

    expected_result = a+b;

    DP->dprint(8, "property2::monitor %d::%s() finished execution\n", monitor_id, __FUNCTION__);
}



void 
monitor2::callback_sent_answer(int a) {
  DP->dprint(8, "property2::monitor %d::%s(%d) starts execution\n", monitor_id, __FUNCTION__, a);
  // The driver has finished the task
  
  DP->dprint(8, "The value of num_complete_delta_cycles is now %d\n", num_complete_delta_cycles);
  assert(num_complete_delta_cycles <= 2);
  DP->dprint(6, "property2::monitor %d::%s(%d) first property passed\n", monitor_id, __FUNCTION__, a);
  
  assert(expected_result == a);
  DP->dprint(6, "property2::monitor %d::%s(%d) second  property passed\n", monitor_id, __FUNCTION__, a);
  DP->dprint(8, "property2::monitor %d::%s() finished execution\n",monitor_id, __FUNCTION__);
}

#endif
