#ifdef MONITOR_3

#include "monitor3.h"

  
// The constructor
monitor3::monitor3(mon_observer* obs, adder* obj1) : mon_prototype() {
  observer = obs;
  object1 = obj1;
  
  DP->dprint(7, "monitor3::constructor(): registering with the event\n");
  
  observer->register_monitor(this, &(object1->addition_event));
  
  DP->dprint(7, "monitor3::constructor(): finished execution\n");
}
  
const char*  
monitor3::to_string() const {
  return "Monitor 3: adder::_a > 0 @ addition_event notification";
}


void 
monitor3::callback_event_notified(sc_event* event) {
  DP->dprint(9, "monitor3::%s() starts execution\n", __FUNCTION__);

  // Check the property below
  sc_assert((object1->_a) >= 0);
  
  DP->dprint(9, "monitor3::%s() finished execution\n", __FUNCTION__);
}


#endif
