#ifndef VER_OBSERVER_H
#define VER_OBSERVER_H

#include <systemc>

#ifdef MONITOR_1
#include "monitor1.h"
#endif

#ifdef MONITOR_2
#include "monitor2.h"
#endif

#ifdef MONITOR_3
#include "monitor3.h"
#endif

#ifdef MONITOR_0
#include "monitor.cc"
#endif


class adder;

/**
 * This object is derived from mon_observer defined in the SystemC
 * modified kernel. Thus, we can pass it as an argument to the classes
 * implementing the properties.
 */
class ver_observer : public mon_observer {
  
 public:

  // The constructor
  ver_observer(unsigned int verbosity, int num_monitors, adder* addy) : mon_observer(verbosity) {
    

#ifdef MONITOR_2 // This needs to be here because we expect the first
		 // n monitors in the list to be of type Monitor2
    for (int i = 0; i < num_monitors; i++) {
      monitor2* mon2 = new monitor2(this);
      mons.push_back(mon2);
    }
#endif

#ifdef MONITOR_1
    for (int i = 0; i < num_monitors; i++) {
      monitor1* my_monitor = new monitor1(this, addy);
      mons.push_back(my_monitor);
    }
#endif

#ifdef MONITOR_3
    for (int i = 0; i < num_monitors; i++) {
      monitor3* mon3 = new monitor3(this, addy);
      mons.push_back(mon3);
    }
#endif

#ifdef MONITOR_0
    for (int i = 0; i < num_monitors; i++) {
      test_monitor0* mon0 = new test_monitor0(this, addy);
      mons.push_back(mon0);
    }
#endif
    

    printf("There are %d monitors in props\n", mon_observer::mons.size());
  }

  
  
  
};

#endif
