/**
 * Defines the basic functionality of a module that initiates a
 * request through a TLM channel.
 */

#ifndef BASIC_MASTER_H
#define BASIC_MASTER_H


#include <systemc.h>
#include "basic_protocol.h"
#include "basic_module.h"
#include "tlm.h"

using basic_protocol::basic_request;
using tlm::tlm_nonblocking_put_if;

namespace user {

template< typename TRANS, typename PAYLD >
class basic_master : 
    public sc_module,
    virtual public basic_module {
  
public:
  
  nb_out_port_t out_port; // The output port
  

  // The constructor
  basic_master(sc_module_name module_name) : 
    sc_module(module_name),
    out_port("out_port") {
  }

}; // basic_master

}; // namespace user
#endif
