/**
 * This module will provide the most fundamental functionality that
 * will be inherited by the other modules.
 */

#ifndef BASIC_MODULE_H
#define BASIC_MODULE_H

#define CONDPRINT(a,b) if (a <= debug_level) {b;}

#include <stdarg.h> // for variable argument functions
#include <stdio.h>
#include <systemc>

#include "tlm.h"
#include "request.h"
#include "basic_protocol.h"



namespace user {

  class basic_module {
    
  public:

    // Constructor
    basic_module();

    // Standard setter
    void set_debug_level(unsigned int new_debug_level);

    // Debugging print
    void dprint(unsigned int level, const char* format, ...) const;

    
  protected:

    unsigned int debug_level; //for debugging printing

  }; // basic_module

}; // namespace


#endif
