#ifndef BOUNDED_TRANSACTION_SET
#define BOUNDED_TRANSACTION_SET

#include "bus_types.h"
#include "bounded_set.h"

using user::bounded_set;

namespace user {
  
  /**
   * Comparison function for objects of type request. Used to define
   * the set container for our bounded queue.
   */
  struct request_comp {
    bool operator()(const TRANS_TYPE o1, const TRANS_TYPE o2) {
      return o1->get_request_id() <= o2->get_request_id();
    }
  };
  
  
  class bounded_transaction_set : 
    bounded_set<TRANS_TYPE, request_comp, std::set<TRANS_TYPE>::const_iterator> {
  };
  

}; //namespace
#endif
