#ifndef MY_OBSERVER_H
#define MY_OBSERVER_H

#include <systemc>

#ifdef PROPERTY_1
#include "property1.h"
#endif

#ifdef PROPERTY_2
#include "property2.h"
#endif

// forward
class airline::flight_planner;
class airline::io_module;
class airline::master_module;

class my_observer : public mon_observer {
  
public:
  my_observer(airline::flight_planner* object1, unsigned int num_monitors) : mon_observer(0) {
    
    vect_mon_t* vect_mon1 = new vect_mon_t;
    vect_mon_t* vect_mon2 = new vect_mon_t;

    for (unsigned int i=0; i < num_monitors; i++) {
      
#ifdef PROPERTY_1
      // Populate the first vector
      property1* mon1 = new property1(this, object1);
      vect_mon1->push_back(mon1);
#endif

#ifdef PROPERTY_2
      // Populate the second vector
      property2* mon2 = new property2(this);
      vect_mon2->push_back(mon2);
#endif
    }
    


    mon_observer::mon_vectors.push_back(vect_mon1);
    mon_observer::mon_vectors.push_back(vect_mon2);
  }
  
  
}; // class

#endif
